import java.util.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.sunpress.actions.ServletAction;
import com.sunpress.actions.ActionFactory;
import com.sunpress.beans.RegistrationDB;

public class CentralServlet extends HttpServlet {
	private ActionFactory actionFactory = new ActionFactory();
	private ResourceBundle bundle;

	public void init(ServletConfig config)throws ServletException{
		super.init(config);

		try {
			bundle = ResourceBundle.getBundle("actions");
		}
		catch(MissingResourceException e) {
			throw new ServletException(e);
		}
		ServletContext context = getServletContext();
		context.setAttribute("action-bundle", bundle);
		context.setAttribute("register", new RegistrationDB());
	}
	public synchronized void service(HttpServletRequest req,
					    	HttpServletResponse res)
							throws IOException, ServletException {
		ServletAction action = getAction(req);
		action.perform(this, req, res);
		action.route(this, req, res);
	}
	private ServletAction getAction(HttpServletRequest req) 
										throws ServletException {
		String key = req.getParameter("action");
		String classname = (String)bundle.getObject(key);
		ClassLoader loader = getClass().getClassLoader(); 

		try {
			return actionFactory.getAction(classname, loader);
		}
		catch(Exception e) {
			throw new ServletException(e);
		}
	}
}
