package com.sunpress.actions;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.sunpress.actions.routers.*;
import com.sunpress.beans.*;

public class RegisterAction extends ServletActionImpl { 
	private String first, last, email;

	public synchronized void perform(HttpServlet servlet,
						HttpServletRequest req, HttpServletResponse res)
						throws IOException, ServletException {
		readParameters(req);

		if(inputComplete() && validEmailAddress()) {
			ServletContext context = servlet.getServletContext();
			RegistrationDB regDB = (RegistrationDB)
										context.getAttribute("register");

			User user = regDB.addUser(first, last, email);
			req.getSession().setAttribute("user", user);
			success = true;
		}
		else
			success = false;
	}
	public Router createRouter() {
		return new RegisterRouter();
	}
	public boolean validEmailAddress() {
		return email.endsWith(".com") || email.endsWith(".net") ||
				 email.endsWith(".org") || email.endsWith(".edu");
	}
	public boolean inputComplete() {
		return !first.equals("") && !last.equals("") && 
				 !email.equals("");
	}
	private void readParameters(HttpServletRequest req) {
		first = req.getParameter("firstName");
		last = req.getParameter("lastName");
		email = req.getParameter("emailAddress");
	}
}
