package com.sunpress.actions;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import com.sunpress.actions.routers.Router;

public abstract class ServletActionImpl implements ServletAction {
	protected boolean success = false;
	protected Router router = null;

	public synchronized void route(HttpServlet servlet, 
				HttpServletRequest req, HttpServletResponse res) 
					throws IOException, ServletException {
		if(router == null)
			router = createRouter();

		router.route(servlet, req, res, this);
	}
	public boolean success() {
		return success; // false by default
	}
	// extending class must also implement perform()
	public abstract Router createRouter();
}
