package com.sunpress.actions.routers;

import java.util.ResourceBundle;
import java.io.IOException;
import javax.servlet.*;
import javax.servlet.http.*;

public abstract class RouterImpl implements Router { 
	ResourceBundle bundle;

	protected void loadBundle(HttpServlet servlet) {
		ServletContext context = servlet.getServletContext();
		bundle = (ResourceBundle)context.getAttribute(
												"action-bundle");
	}
	protected String stringFromBundle(HttpServlet servlet,
									  String key) {
		if(bundle == null) 
			loadBundle(servlet);

		return (String)bundle.getObject(key);
	}
	protected String encodeURLFromBundle(HttpServlet servlet,
										  HttpServletResponse res,
									  	  String key) {
		if(bundle == null) 
			loadBundle(servlet);

		return res.encodeURL((String)bundle.getObject(key));
	}
	protected String encodeRedirectURLFromBundle(
	   									HttpServlet servlet, 
										HttpServletResponse res, 
										String key) {
		if(bundle == null) 
			loadBundle(servlet);

		return res.encodeRedirectURL((String)
									  bundle.getObject(key));
	}
	protected void forward(HttpServlet servlet, 
			HttpServletRequest req, HttpServletResponse res, 
			String where) throws IOException, ServletException {
		ServletContext c = servlet.getServletContext();

		// Resin requires an absolute path for forwarding
		RequestDispatcher d = c.getRequestDispatcher("/" + 
								res.encodeURL(where));
		d.forward(req, res);
	}
	protected void redirect(HttpServletResponse res, 
							String where) 
							throws java.io.IOException, 
								   ServletException {
		res.sendRedirect(res.encodeURL(where));
	}
}
