package tags.jdbc;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;

import beans.jdbc.Query;

public abstract class ColumnIteratorTag extends BodyTagSupport {
   protected int columnCount, currentColumn;
   protected ResultSet rs;
   protected ResultSetMetaData rsmd;
   protected String query;

   public void setQuery(String query) {
      this.query = query;
   }
   public int doStartTag() throws JspException {
      rs = Query.getResult(pageContext, query);

      try {
         rsmd = rs.getMetaData();
         columnCount = rsmd.getColumnCount();
         currentColumn = 1;
      }
      catch(Exception ex) {
         throw new JspException(ex.getMessage());
      }
      if(columnCount > 0) return EVAL_BODY_TAG;   
      else                return SKIP_BODY;
   }
   public int doAfterBody() throws JspException {
      if(++currentColumn <= columnCount) {
         return EVAL_BODY_TAG;
      }
      else {
         try {
            bodyContent.writeOut(getPreviousOut());
         }
         catch(java.io.IOException e) {
              throw new JspException(e.getMessage());
         }
      }
      return SKIP_BODY;
   }
}
