package tags.jdbc;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyTagSupport;

import beans.jdbc.DbConnectionPool;
import beans.util.ResourceException;

public class PrepareStatementTag extends BodyTagSupport {
   private String scope = "page";

   public void setScope(String scope) {
      this.scope = scope;
   }
   public int doAfterBody() throws JspException {
      DbConnectionPool pool = (DbConnectionPool)
                              pageContext.getServletContext().
                              getAttribute("db-connection-pool");
      Connection con;
      try {
         con = (Connection)pool.getResource();
      }
      catch(ResourceException ex) {
         throw new JspException(ex.getMessage());
      }
      PreparedStatement ps = prepareStatement(con);
      pageContext.setAttribute(id,ps,getConstantForScope(scope));

      return SKIP_BODY;
   }
   private PreparedStatement prepareStatement(Connection con)
                                             throws JspException {
      PreparedStatement pstate = null;
      try {
         pstate = con.prepareStatement(bodyContent.getString(),
                           ResultSet.TYPE_SCROLL_INSENSITIVE,
                           ResultSet.CONCUR_READ_ONLY);
      }
      catch(SQLException ex) {
         throw new JspException(ex.getMessage());
      }
      return pstate;
   }
   private int getConstantForScope(String scope) {
      int constant = PageContext.PAGE_SCOPE;

      if(scope.equalsIgnoreCase("page")) 
         constant = PageContext.PAGE_SCOPE;
      else if(scope.equalsIgnoreCase("request")) 
         constant = PageContext.REQUEST_SCOPE;
      else if(scope.equalsIgnoreCase("session")) 
         constant = PageContext.SESSION_SCOPE;
      else if(scope.equalsIgnoreCase("application")) 
         constant = PageContext.APPLICATION_SCOPE;

      return constant;
   }
}
