package tags.jdbc;

import java.sql.*;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;
import beans.jdbc.Query;
import beans.jdbc.DbConnectionPool;
import beans.util.ResourceException;

public class QueryTag extends BodyTagSupport {
   private String scope = "page";
   private boolean update = false, driverLoaded = false;

   public void setId(String id) {
      this.id = id;
   }
   public void setScope(String scope) {
      this.scope = scope;
   }
   public void setUpdate(boolean update) {
      this.update = update;
   }
   public int doEndTag() throws JspException {
      DbConnectionPool pool = (DbConnectionPool)
                              pageContext.getServletContext().
                              getAttribute("db-connection-pool");
      Connection conn;

      try {
         conn = (Connection)pool.getResource(10000);
      }
      catch(ResourceException cex) {
         throw new JspException(cex.getMessage());
      }

      if(bodyContent != null) {
         try {
            String query = bodyContent.getString();
            Statement statement = conn.createStatement(
                                ResultSet.TYPE_SCROLL_INSENSITIVE,
                                ResultSet.CONCUR_READ_ONLY);
            ResultSet rs = null;
            int rows = 0; 

            if(update) {
               rows = statement.executeUpdate(query);
               Query.save(new Query(statement, rows), 
                          pageContext, id, scope);
            }
            else {
               rs = statement.executeQuery(query);
               Query.save(new Query(statement, rs), 
                          pageContext, id, scope);
            }
         }
         catch(SQLException ex) {
            throw new JspException(ex.getMessage());
         }
      }
      return EVAL_PAGE;
   }
}
