package tags.jdbc;

import java.sql.Connection;
import java.sql.Statement;

import javax.servlet.ServletContext;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

import beans.jdbc.DbConnectionPool;
import beans.jdbc.Query;

public class ReleaseTag extends TagSupport {
   private String query = "null";

   public void setQuery(String query) { 
      this.query = Query.QUERY_PREFIX + query; 
   }
   public int doEndTag() throws JspException {
      Query q = (Query)pageContext.findAttribute(query);

      if(q == null) {
         throw new JspException("Can't find query " + query);
      }
      ServletContext app  = pageContext.getServletContext();
      DbConnectionPool pool = (DbConnectionPool)
                              pageContext.getServletContext().
                              getAttribute("db-connection-pool");
      try {
         pool.recycleResource(q.getStatement().getConnection());
      }
      catch(java.sql.SQLException ex) {
         throw new JspException(ex.getMessage());
      }
      pageContext.removeAttribute(query);
      
      return EVAL_PAGE;
   }
}
