package tags.jdbc;

import javax.servlet.ServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

public class ShowTableTag extends TagSupport {
   private String database, query, border, padding;

   public void setDatabase(String db) { this.database = db; }
   public void setQuery(String query) { this.query = query; }
   public void setBorder(String border) { this.border = border; }
   public void setCellPadding(String padding) { 
      this.padding = padding; 
   }
   public int doEndTag() throws JspException {
      try {
         ServletRequest req = pageContext.getRequest();

         req.setAttribute("database", database);
         req.setAttribute("query", query);
         req.setAttribute("table_border", new Integer(border));
         req.setAttribute("cell_padding", new Integer(padding));
   
         try {
            pageContext.getOut().flush();
            pageContext.include(
                        "WEB-INF/jsp/scripts/showDbTable.jsp");
         }
         catch(javax.servlet.ServletException ex) {
            throw new JspException(ex.getMessage());
         }
      }
      catch(java.io.IOException ex) {
         throw new JspException(ex.getMessage());
      }
      return EVAL_PAGE;
   }
}
