package beans.xml.xslt;

import java.io.InputStream;
import java.io.Reader;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.JspWriter;

import org.apache.xalan.xslt.XSLTInputSource;
import org.apache.xalan.xslt.XSLTProcessor;
import org.apache.xalan.xslt.XSLTProcessorFactory;
import org.apache.xalan.xslt.XSLTResultTarget;

public class XSLTProcessorBean implements java.io.Serializable {
   public void process(Reader xmlrdr, InputStream xslstrm,
							  JspWriter writer)
                    throws java.io.IOException, ServletException {
      process(new XSLTInputSource(xmlrdr),   
              new XSLTInputSource(xslstrm), writer);
   }
   public void process(XSLTInputSource xmlsrc, 
                       XSLTInputSource xslsrc,
							  JspWriter writer)
                    throws java.io.IOException, ServletException {
      try {
         XSLTProcessorFactory.getProcessor().process(
                           xmlsrc, xslsrc, 
                           new XSLTResultTarget(writer));
      }
      catch(Exception ex) {
         throw new ServletException(ex);
      }
   }
}
