package tags.app;

import java.util.Enumeration;
import javax.servlet.ServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class UpdatePricesTag extends TagSupport {
   public int doEndTag() throws JspException {
      Document document = (Document)pageContext.getAttribute(
                                 "document", 
                                 PageContext.APPLICATION_SCOPE);
      if(document != null)
         updatePrices(document);

      return EVAL_PAGE;
   }
   private void updatePrices(Node node) throws JspException {
      ServletRequest request = pageContext.getRequest();
      NodeList list = node.getChildNodes();
      int childCnt = list.getLength();

      if(childCnt > 0) { 
           String lastTitle = null;

         for(int i=0; i < childCnt; ++i) {
            Node next = list.item(i); 
            String value = next.getNodeValue();

            if(next.getNodeType() == Node.ELEMENT_NODE) {
               String nodeName = next.getNodeName();
               String text = getElementText(next);

               if(text != null) {
                  if(nodeName.equals("title")) {
                     lastTitle = text;
                  }
                  else if(nodeName.equals("price")) {
                     String pval = getParameterValue(request,
                                                  lastTitle);
                     if(pval != null && !pval.equals(text))
                        setElementText(next, pval);
                  }
               }
               updatePrices(next);
            }
         }
      }
   }
   private String getParameterValue(ServletRequest request,
                                    String param) {
      Enumeration parameterNames = request.getParameterNames();

      while(parameterNames.hasMoreElements()) {
         String next = (String)parameterNames.nextElement();

         if(next.equals(param))
            return request.getParameterValues(next)[0];
      }
      return null;
   }
   private String getElementText(Node element) {
      Node child = element.getFirstChild();
      String text = null;

      if(child != null)
         text = child.getNodeValue();

      return text;
   }
   private void setElementText(Node element, String text) {
      Node child = element.getFirstChild();

      if(child != null)
         child.setNodeValue(text);
   }
}
