package tags.xml.dom;

import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import org.w3c.dom.Document;
import beans.xml.dom.DOMParserBean;

public class DOMParserTag extends TagSupport { 
   private String xmlFile;
   private boolean force;

   public void setXmlFile(String xmlFile) {
      this.xmlFile = xmlFile;
      this.force = false;
   }
   public void setId(String id) {
      this.id = id;
   }
   public void setForce(boolean force) {
      this.force = force;
   }
   public int doStartTag() throws JspException {
      Document document = (Document)pageContext.
                           getServletContext().getAttribute(id);

      if(document == null || force)
         parse();

      return SKIP_BODY;
   }
   private void parse() throws JspException {
      try {
         pageContext.setAttribute(id, 
                     DOMParserBean.getDocument(xmlFile),
                     PageContext.APPLICATION_SCOPE);
      }
      catch(Exception ex) {
         throw new JspException(ex.getMessage());
      }
   }
   public void release() {
      xmlFile = null;
      force = false;
   }
}
