package tags.xml.dom;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class GetElementValueTag extends TagSupport {
   private Node element = null;

   public void setElement(Node element) { 
      this.element = element; 
   }
   public void setId(String id) { 
      this.id = id; 
   }
   public int doEndTag() throws JspException {
      if(element.getNodeType() == Node.ELEMENT_NODE) {
         String value = getElementText(element);
         pageContext.setAttribute(id, value);
      }
      else
         throw new JspException("Node must be an element");

      return EVAL_PAGE;
   }
   public void release() {
      element = null;
   }
   private String getElementText(Node element) {
      Node child = element.getFirstChild();
      String text = null;

      if(child != null)
         text = child.getNodeValue();

      return text;
   }
}
