package tags.xml.dom;

import java.util.StringTokenizer;
import java.util.NoSuchElementException;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import org.w3c.dom.Node;

public class IfNodeNameEqualsTag extends TagSupport {
   private Node node = null;
   private String names = null;

   public void setNode(Node node)     { this.node = node; }
   public void setNames(String names) { this.names = names; }

   public int doStartTag() throws JspException {
      StringTokenizer tok = new StringTokenizer(names);
      String nextName = null, nodeName = node.getNodeName();
      boolean nameFound = false;

      try {
         while(!nameFound)
            nameFound = nodeName.equals(tok.nextToken());
      }
      catch(NoSuchElementException ex) {
         // no more tokens
      }
      return nameFound ? EVAL_BODY_INCLUDE : SKIP_BODY;
   }
   public void release() {
      names = null;
      node = null;
   }
}
