package tags.xml.xpath;

import java.util.Collection;
import java.util.Vector;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import beans.xml.dom.DOMParserBean;
import beans.xml.xpath.XPathBean;
import tags.util.IteratorTag;

public class XPathTag extends IteratorTag {
   private String file, expr;
   private boolean force = false;

   public void setXmlFile(String file) { this.file = file; }
   public void setExpr(String expr)    { this.expr = expr; }
   public void setForce(boolean force) { this.force = force; }

   public int doStartTag() throws JspException {
      Document document = (Document)pageContext.getAttribute(file,
                                     PageContext.SESSION_SCOPE);
      NodeList list = null;

      if(force || document == null) {
         try {
            document = DOMParserBean.getDocument(file);
         }
         catch(Exception ex) {
            throw new JspException(ex.getMessage());
         }
         pageContext.setAttribute(file, document,
                                   PageContext.SESSION_SCOPE);
      }
      try {
         setCollection(
               collection(XPathBean.process(document, expr)));
      }
      catch(Exception ex) {
         throw new JspException(ex.getMessage());
      }
      return super.doStartTag();
   }
   public void release() {
      file = expr = null;
      force = false;
   }
   private Collection collection(NodeList list) {
      Vector vector = new Vector();
      int length = list.getLength();

      for(int i=0; i < length; ++i) {
         vector.addElement(list.item(i));
      }
      return vector;
   }
}
