package tags.xml.xslt;

import java.io.StringReader;
import javax.servlet.ServletContext;
import javax.servlet.jsp.JspException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.tagext.BodyTagSupport;
import beans.xml.xslt.XSLTProcessorBean;

public class XSLTApplyTag extends BodyTagSupport {
   private String xsl;

   public void setXsl(String xsl) { 
      this.xsl = xsl; 
   }
   public int doAfterBody() throws JspException {
      XSLTProcessorBean xslBean = new XSLTProcessorBean();
      ServletContext context = pageContext.getServletContext();
      String body = bodyContent.getString().trim();

      try {
         if(body.equals("")) {
            throw new JspException("The body of this tag " +
                                   "must be XML.");
         }
         xslBean.process(new StringReader(body),
                             context.getResourceAsStream(xsl),
                             getPreviousOut());
      }
      catch(Exception ex) {
         throw new JspException(ex.getMessage());
      }
      return SKIP_BODY;
   }
}
