package tags.jdbc;

import java.sql.*;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;
import tags.jdbc.beans.Query;

public class ColumnNamesTag extends BodyTagSupport {
   private ResultSet rs;
   private ResultSetMetaData rsmd;
   private int columnCount, currentColumn;
   private String id, query;

   public void setId(String id) { 
      this.id = id; 
   }
   public void setQuery(String query) { 
      this.query = query; 
   }
   public int doStartTag() throws JspException {
      rs = Query.getResult(pageContext, query);

      try {
         rsmd = rs.getMetaData();
         columnCount = rsmd.getColumnCount();
         currentColumn = 1;
      }
      catch(Exception ex) {
         throw new JspException(ex.getMessage());
      }
      if(columnCount > 0) return EVAL_BODY_TAG;   
      else                return SKIP_BODY;
   }
   public void doInitBody() throws JspException {
      try {
         pageContext.setAttribute(id, 
                             rsmd.getColumnName(currentColumn++));
      }
      catch(java.sql.SQLException ex) {
         throw new JspException(ex.getMessage());
      }
   }
   public int doAfterBody() throws JspException {
      if(currentColumn <= columnCount) {
         try {
            pageContext.setAttribute(id, 
                             rsmd.getColumnName(currentColumn++));
         }
         catch(Exception ex) {
            throw new JspException(ex.getMessage());
         }
         return EVAL_BODY_TAG;
      }
      else                        
         return SKIP_BODY;
   }
   public int doEndTag() throws JspException {
      try {
         if(bodyContent != null)
            bodyContent.writeOut(pageContext.getOut());
      }
      catch(Exception e) { // IO or SQL exception
         throw new JspException(e.getMessage());
      }
      return EVAL_PAGE;
   }
}
