package tags.jdbc;

import java.sql.*;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;
import tags.jdbc.beans.Query;

public class ColumnsTag extends BodyTagSupport {
   private ResultSet rs;
	private ResultSetMetaData rsmd;
   private int columnCount, currentColumn;
   private String query, columnName, columnValue;

   public void setQuery(String query) {
      this.query = query;
   }
   public void setColumnName(String columnName) {
      this.columnName = columnName;
   }
   public void setColumnValue(String columnValue) {
      this.columnValue = columnValue;
   }
   public int doStartTag() throws JspException {
      rs = Query.getResult(pageContext, query);

      try {
         rsmd = rs.getMetaData();
         columnCount = rsmd.getColumnCount();
         currentColumn = 1;
      }
      catch(Exception ex) {
         throw new JspException(ex.getMessage());
      }
      if(columnCount > 0) return EVAL_BODY_TAG;   
      else                return SKIP_BODY;
   }
   public void doInitBody() throws JspException {
      try {
         pageContext.setAttribute(getColumnAttributeName(), 
                        rsmd.getColumnName(currentColumn));

         pageContext.setAttribute(getColumnAttributeValue(), 
                        (rs.getString(currentColumn++)).trim());
      }
      catch(SQLException ex) {
         throw new JspException(ex.getMessage());
      }
   }
   public int doAfterBody() throws JspException {
      if(currentColumn <= columnCount) {
         try {
            pageContext.setAttribute(columnName, 
                               rsmd.getColumnName(currentColumn));

            pageContext.setAttribute(columnValue, 
                          (rs.getString(currentColumn++)).trim());
         }
         catch(Exception ex) {
            throw new JspException(ex.getMessage());
         }
         return EVAL_BODY_TAG;
      }
      else                        
         return SKIP_BODY;
   }
   public int doEndTag() throws JspException {
      try {
         if(bodyContent != null)
            bodyContent.writeOut(pageContext.getOut());
      }
      catch(java.io.IOException e) {
         throw new JspException(e.getMessage());
      }
      return EVAL_PAGE;
   }
	private String getColumnAttributeName() {
		return columnName == null ? "column_name" : columnName;
	}
	private String getColumnAttributeValue() {
		return columnValue == null ? "column_value" : columnValue;
	}
}
