package tags.jdbc;

import java.sql.*;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyTagSupport;
import beans.jdbc.DbConnectionPool;
import beans.jdbc.ConnectionException;

public class PrepareStatementTag extends BodyTagSupport 
									   implements Constants {
   private String id, scope = "page";

   public void setId(String id) {
      this.id = id;
   }
   public void setScope(String scope) {
      this.scope = scope;
   }
   public int doEndTag() throws JspException {
      DbConnectionPool pool = (DbConnectionPool)
                              pageContext.getServletContext().
                              getAttribute(DBPOOL_KEY);
      Connection con;
      try {
         con = (Connection)pool.getConnection();
      }
      catch(ConnectionException ex) {
         throw new JspException(ex.getMessage());
      }
      PreparedStatement ps = prepareStatement(con);
      pageContext.setAttribute(id,ps,getConstantForScope(scope));

      return EVAL_PAGE;
   }
   private PreparedStatement prepareStatement(Connection con)
                                             throws JspException {
      PreparedStatement pstate = null;
      try {
         pstate = con.prepareStatement(bodyContent.getString(),
                           ResultSet.TYPE_SCROLL_INSENSITIVE,
                           ResultSet.CONCUR_READ_ONLY);
      }
      catch(SQLException ex) {
         throw new JspException(ex.getMessage());
      }
      return pstate;
   }
   private int getConstantForScope(String scope) {
      int constant = PageContext.PAGE_SCOPE;

      if(scope.equalsIgnoreCase("page")) 
         constant = PageContext.PAGE_SCOPE;
      else if(scope.equalsIgnoreCase("request")) 
         constant = PageContext.REQUEST_SCOPE;
      else if(scope.equalsIgnoreCase("session")) 
         constant = PageContext.SESSION_SCOPE;
      else if(scope.equalsIgnoreCase("application")) 
         constant = PageContext.APPLICATION_SCOPE;

      return constant;
   }
}
