package tags.regions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.tagext.TagSupport;

import beans.regions.Content;
import beans.regions.Section;

public class PutTag extends BodyTagSupport {
   private String section, role, content, direct = null;

   public void setSection(String section){this.section = section;}
   public void setRole   (String role)   {this.role    = role;   }
   public void setDirect (String direct) {this.direct  = direct; }
   public void setContent(String cntnt)  {this.content = cntnt;  }
	
   public String getSection() { return section; }
   public String getRole()    { return role;    }
   public String getContent() { return content; }
   public String getDirect()  { return direct;  }

   public int doEndTag() throws JspException {
      HttpServletRequest request = 
						  (HttpServletRequest)pageContext.getRequest();
   	
      if(role != null && !request.isUserInRole(role))
      	return EVAL_PAGE;

      RegionTag regionTag = (RegionTag)getAncestor(
                                       "tags.regions.RegionTag");
      if(regionTag == null)
         throw new JspException("No RegionTag ancestor");

      regionTag.put(new Section(section, getActualContent(), 
												     isDirect()));
      return EVAL_PAGE;
   }
   public String isDirect() {
      if(hasBody()) return "true";
      else          return direct == null ? "false" : "true";
   }
   public void release() {
      super.release();
      section = content = direct = role = null;
   }
   private String getActualContent() throws JspException {
      String bodyAndContentMismatchError = 
         "Please specify template content in this tag's body " +
         "or with the content attribute, but not both.",
             bodyAndDirectMismatchError = 
                "If content is specified in the tag body, the " +
                "direct attribute must be true.";

      boolean hasBody = hasBody(); 
		boolean contentSpecified = (content != null);

      if((hasBody && contentSpecified) || 
			(!hasBody && !contentSpecified))
         throw new JspException(bodyAndContentMismatchError);

      if(hasBody && direct != null && 
			direct.equalsIgnoreCase("false"))
         throw new JspException(bodyAndDirectMismatchError);

      return hasBody ? bodyContent.getString() : content;
   }
   private boolean hasBody() {
      if (bodyContent == null)
         return (false);
      return ! bodyContent.getString().equals("");
   }
   private TagSupport getAncestor(String className) 
                                 throws JspException {
      Class klass = null; // cant name variable "class"
      try {
         klass = Class.forName(className);
      }
      catch(ClassNotFoundException ex) {
         throw new JspException(ex.getMessage());
      }
      return (TagSupport)findAncestorWithClass(this, klass);
   }
}
