package tags.regions;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;

import beans.regions.Content;
import beans.regions.Region;

// Store the region member variable from RegionTag in
// the specified scope.

public class RegionDefinitionTag extends RegionTag {
	protected String scope = "application";
	protected Region base = null;

	public void setScope(String scope) {
		this.scope = scope;
	}
   public int doStartTag() throws JspException {
		// should check attributes here, eg: region and template
		// cannot be specified at the same time
		createRegionFromRegion();

		if(region == null)
			createRegionFromTemplate();

		return EVAL_BODY_INCLUDE;
	}
   public int doEndTag() throws JspException {
		pageContext.setAttribute(id, region, getScope());
      return EVAL_PAGE;
   }
	protected int getScope() {
      int constant = PageContext.APPLICATION_SCOPE;

      if("page".equalsIgnoreCase(scope)) 
         constant = PageContext.PAGE_SCOPE;
      else if("request".equalsIgnoreCase(scope)) 
         constant = PageContext.REQUEST_SCOPE;
      else if("session".equalsIgnoreCase(scope)) 
         constant = PageContext.SESSION_SCOPE;

      return constant;
   }
   public void release() {
		super.release();
		scope = "application";
   }
}
