package tags.regions;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;

import beans.regions.Section;
import beans.regions.Region;
import beans.regions.RegionStack;

public class RegionTag extends TagSupport {
   protected Region region=null;
   protected String regionKey=null, template=null;

   public void setTemplate(String template) {
      this.template = template;
   }
   public void setRegion(String regionKey) {
      this.regionKey = regionKey;
   }
	protected boolean findRegionByKey() throws JspException {
		if(regionKey != null) {
			region = (Region)pageContext.findAttribute(regionKey);
			if(region == null) {
				throw new JspException("can't find page definition " +
										    "attribute with this key: " + 
											 regionKey);
			}
		}	
		return region != null;
	}
	protected void createRegionFromTemplate() throws JspException {
		if(template == null)
			throw new JspException("can't find template");

      region = new Region(template);
	}
	protected void createRegionFromRegion() throws JspException {
		findRegionByKey();

		if(region == null)
			return;

      region = new Region(region.getContent(),   // the template
								  region.getSections()); // sections
	}
   public void put(Section section) {
      region.put(section);
   }
   public void release() {
      super.release();
      region = null;
		regionKey = null;
		template = null;
   }
}
