package tags.regions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;

import beans.regions.Content;
import beans.regions.Section;
import beans.regions.Region;
import beans.regions.RegionStack;

public class RenderTag extends RegionTag {
   protected String sectionName=null, role=null;

   public void setRegion(String key) { this.regionKey = key; }
   public void setTemplate(String s) { this.template = s;    }
   public void setSection(String s)  { this.sectionName = s; }
   public void setRole(String s)     { this.role = s;        }

   public String getSection() { return sectionName; }
   public String getRole()    { return role; }
	
	protected boolean renderingRegion() {
		return sectionName == null;
	}
	protected boolean renderingSection() {
		return sectionName != null;
	}
	public int doStartTag() throws JspException {
      HttpServletRequest request = (HttpServletRequest)
												pageContext.getRequest();

      if(role != null && !request.isUserInRole(role))
      	return SKIP_BODY;

		if(renderingRegion()) {
			if(!findRegionByKey()) {
				createRegionFromTemplate();
			}
			RegionStack.push(pageContext, region);
		}
		return EVAL_BODY_INCLUDE;
	}
	public int doEndTag() throws JspException {
      Region region = RegionStack.peek(pageContext);

		if(region == null)
      	throw new JspException("Can't find region");

   	if(renderingSection()) {
			Section section = region.get(sectionName);

			if(section == null)
				return EVAL_PAGE; // ignore missing sections

			section.render(pageContext);
		}
		else if(renderingRegion()) {
     		try {
      		region.render(pageContext);
				RegionStack.pop(pageContext);
			}
      	catch(Exception ex) { // IOException or ServletException
        		throw new JspException(ex.getMessage());
      	}
		}
		return EVAL_PAGE;
   }
   public void release() {
      super.release();
      sectionName = role = null;
   }
}
