package tags.security;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;

public class EnforceLoginTag extends TagSupport 
								  implements Constants {
   private String loginPage, errorPage;

   public void setLoginPage(String loginPage) {
      this.loginPage = loginPage;
   }
   public void setErrorPage(String errorPage) {
      this.errorPage = errorPage;
   }
   public int doEndTag() throws JspException {
      HttpSession session = pageContext.getSession();
      HttpServletRequest req = (HttpServletRequest)pageContext.
                                                 getRequest();
      String protectedPage = req.getServletPath();

      if(session.getAttribute(USER_KEY) == null) {
         session.setAttribute(LOGIN_PAGE_KEY,     loginPage);
         session.setAttribute(ERROR_PAGE_KEY,     errorPage);
         session.setAttribute(PROTECTED_PAGE_KEY, protectedPage);

         try {
            pageContext.forward(loginPage);
            return SKIP_PAGE;
         }
         catch(Exception ex) {
            throw new JspException(ex.getMessage());
         }
      }
      return EVAL_PAGE;
   }
   public void release() {
      loginPage = errorPage = null;
   }
}
