package tags.xml.dom;

import java.io.FileInputStream;
import java.io.StringReader;

import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;

import beans.xml.dom.DOMParserBean;

public class DOMParserTag extends BodyTagSupport { 
   private String xmlFile = null, scope = null;
   private boolean force = false;

   public void setXmlFile(String xmlFile) {
      this.xmlFile = xmlFile;
      this.force = false;
   }
   public void setScope(String scope) {
      this.scope = scope;
   }
   public void setForce(boolean force) {
      this.force = force;
   }
   public int doEndTag() throws JspException {
      Document document = (Document)pageContext.
                           		   getAttribute(id, getScope());
		InputSource is;

		if((scope != null && id == null) ||
		   (scope == null && id != null)) {
			throw new JspException("scope and id must be " +
									     "specified together");
		}

      if(document == null || force) { 
			is = getInputSource();

      	try {
        		pageContext.setAttribute(id, 
        					  DOMParserBean.getDocument(is), getScope());
      	}
      	catch(Exception ex) {
        		throw new JspException(ex.getMessage());
      	}
		}
      return EVAL_PAGE;
	}
	private InputSource getInputSource() throws JspException {
		InputSource is = null;

		if(xmlFile != null) {
			try {
				is = new InputSource(new FileInputStream(xmlFile));
			}
			catch(java.io.FileNotFoundException ex) {
				throw new JspException("Can't find " + xmlFile);
			}
		}
		else {
			String body = bodyContent.getString().trim();

         if(body.equals("")) {
        	  	throw new JspException("The body of this tag " +
        	                          "must be XML.");
        	}
			is = new InputSource(new StringReader(body));
		}
      return is;
   }
	private int getScope() {
      int constant = PageContext.PAGE_SCOPE;

      if("page".equalsIgnoreCase(scope)) 
         constant = PageContext.PAGE_SCOPE;
      else if("request".equalsIgnoreCase(scope)) 
         constant = PageContext.REQUEST_SCOPE;
      else if("session".equalsIgnoreCase(scope)) 
         constant = PageContext.SESSION_SCOPE;
      else if("application".equalsIgnoreCase(scope)) 
         constant = PageContext.APPLICATION_SCOPE;

      return constant;
   }
   public void release() {
      xmlFile = null;
      force = false;
		scope = "page";
   }
}
