package tags.xml.sax;

import java.util.StringTokenizer;
import java.util.NoSuchElementException;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import beans.xml.sax.SAXElement;

public class IfElementNameEqualsTag extends TagSupport {
   private SAXElement element = null;
   private String names = null;

   public void setElement(SAXElement element) { 
      this.element = element; 
   }
   public void setNames(String names) { 
      this.names = names; 
   }
   public int doStartTag() throws JspException {
      StringTokenizer tok = new StringTokenizer(names);
      String nextName = null, 
             elementName = element.getLocalName();
      boolean nameFound = false;

      try {
         while(!nameFound)
            nameFound = elementName.equals(tok.nextToken());
      }
      catch(NoSuchElementException ex) {
         // no more tokens
      }
      return nameFound ? EVAL_BODY_INCLUDE : SKIP_BODY;
   }
   public void release() {
      names = null;
      element = null;
   }
}
