package tags.xml.sax;

import java.util.Collection;
import java.util.Vector;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import beans.xml.sax.SAXParserBean;
import tags.util.IteratorTag;

import org.xml.sax.SAXException;

public class SAXParserTag extends IteratorTag {
   private String xmlFile;

   public void setXmlFile(String xmlFile) {
      this.xmlFile = xmlFile;
   }
   public int doStartTag() throws JspException {
      setCollection(getCollection());
      return super.doStartTag();
   }
   public void release() {
      xmlFile = null;
   }
   private Collection getCollection() throws JspException {
      Collection collection = (Collection)
                               pageContext.getAttribute(
                                          xmlFile, 
                                          PageContext.PAGE_SCOPE);
      if(collection == null) {
         try {
            SAXParserBean parserBean = new SAXParserBean();
            collection = parserBean.parse(xmlFile);
            setCollection(collection);
            pageContext.setAttribute(xmlFile,
                                     collection,
                                     PageContext.PAGE_SCOPE);
         }
         catch(java.io.IOException ex) {
               throw new JspException("IO Exception: " +
                                    ex.toString());
         }
         catch(SAXException ex) {
               throw new JspException("SAX Exception" + 
                                    ex.toString());
         }
      }
      return collection;
   }
}
