package tags.xml.xpath;

import javax.servlet.jsp.JspException;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

import beans.xml.dom.DOMParserBean;
import beans.xml.xpath.XPathBean;

import tags.util.IteratorTag;

public class SelectNodesTag extends IteratorTag {
	private XPathTagSupport support = new XPathTagSupport();

   public void setDocument(Document d){ support.setDocument(d);  }
   public void setXmlFile(String file){ support.setXmlFile(file);}
   public void setExpr(String expr)   { support.setExpr(expr);   }
   public void setForce(boolean force){ support.setForce(force); }
   public void setScope(String scope) { support.setScope(scope); }

   public int doStartTag() throws JspException {
      NodeList list = null;

      if(support.force || support.document == null) {
			InputSource is = support.getInputSource();

         try {
            support.setDocument(DOMParserBean.getDocument(is));
         }
         catch(Exception ex) {
            throw new JspException(ex.getMessage());
         }
      }
      try {
         list = XPathBean.process(support.document, support.expr);
      }
      catch(Exception ex) {
         throw new JspException(ex.getMessage());
      }
		pageContext.setAttribute(id, list, support.getScope()); 
      return super.doStartTag();
   }
   public void release() {
		support.release();
   }
}
