package tags.xml.xpath;

import java.io.FileInputStream;
import java.util.Collection;
import java.util.Vector;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

import beans.xml.xpath.XPathBean;

public class XPathTagSupport {
	Document document;
   String xmlFile, expr, scope; 
   boolean force = false;

   public void setDocument(Document doc) { this.document = doc; }
   public void setXmlFile(String file)   { this.xmlFile = file; }
   public void setExpr(String expr)      { this.expr = expr;    }
   public void setForce(boolean force)   { this.force = force;  }
   public void setScope(String scope)    { this.scope = scope;  }

   public void release() {
      xmlFile  = null;
		expr     = null;
      document = null;
      scope    = null;
      force    = false;
   }
   public Collection collection(NodeList list) {
      Vector vector = new Vector();
      int length = list.getLength();

      for(int i=0; i < length; ++i) {
         vector.addElement(list.item(i));
      }
      return vector;
   }
	public InputSource getInputSource() throws JspException {
		InputSource is = null;

		if(xmlFile != null) {
			try {
				is = new InputSource(new FileInputStream(xmlFile));
			}
			catch(java.io.FileNotFoundException ex) {
				throw new JspException("Can't find " + xmlFile);
			}
		}
      return is;
   }
	public int getScope() {
      int constant = PageContext.PAGE_SCOPE;

      if("page".equalsIgnoreCase(scope)) 
         constant = PageContext.PAGE_SCOPE;
      else if("request".equalsIgnoreCase(scope)) 
         constant = PageContext.REQUEST_SCOPE;
      else if("session".equalsIgnoreCase(scope)) 
         constant = PageContext.SESSION_SCOPE;
      else if("application".equalsIgnoreCase(scope)) 
         constant = PageContext.APPLICATION_SCOPE;

      return constant;
   }
}
