package tags.xml.xslt;

import java.io.StringReader;

import javax.servlet.ServletContext;
import javax.servlet.jsp.JspException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.tagext.BodyTagSupport;

import beans.xml.xslt.XSLTProcessorBean;

public class XSLTApplyTag extends BodyTagSupport {
   private String xslt;

   public void setXslt(String xslt) { this.xslt = xslt; }

   public int doEndTag() throws JspException {
      XSLTProcessorBean xsltBean = new XSLTProcessorBean();
      ServletContext context = pageContext.getServletContext();
      String body = bodyContent.getString().trim();

      try {
         if(body.equals("")) {
            throw new JspException("The body of this tag " +
                                   "must be XML.");
         }
         xsltBean.process(new StringReader(body),
                  context.getResourceAsStream(xslt),
                  (HttpServletRequest)pageContext.getRequest(),
                  (HttpServletResponse)pageContext.getResponse());
      }
      catch(Exception ex) {
         throw new JspException(ex.getMessage());
      }
      return EVAL_PAGE;
   }
}
