package tags;

import java.util.Collection;
import java.util.Iterator;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyTagSupport;

public class IteratorTag extends BodyTagSupport {
   private Collection collection;
   private Iterator iterator;

   public void setCollection(Collection collection) {
      this.collection = collection;
   }
   public int doStartTag() throws JspException {
      return collection.size() > 0 ? EVAL_BODY_TAG : SKIP_BODY;
   }
   public void doInitBody() throws JspException {
      iterator = collection.iterator();
      pageContext.setAttribute("item", iterator.next());
   }
   public int doAfterBody() throws JspException {
      if(iterator.hasNext()) {
         pageContext.setAttribute(getId(), iterator.next());
         return EVAL_BODY_TAG;
      }
      else {
         try {
            getBodyContent().writeOut(getPreviousOut());
         }
         catch(java.io.IOException e) {
            throw new JspException(e.getMessage());
         }
         return SKIP_BODY;
      }
   }
}
