import java.io.IOException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServlet;

public class ValidationServlet extends HttpServlet {
   public void service(HttpServletRequest req,
                         HttpServletResponse res)
                     		throws IOException, ServletException {
      String first = req.getParameter("firstName"),
              last = req.getParameter("lastName"),
             email = req.getParameter("emailAddress"),
          errorMsg = "", nextStop = "/registrationComplete.jsp";

      boolean errorDetected = false;

      if(first.equals("") || last.equals("") || 
                             email.equals("")) { 
         errorMsg += "Please fill in all fields."; 
         errorDetected = true; 
      }
      if(email.indexOf("@") == -1 ||
        (!email.endsWith(".com") && !email.endsWith(".edu"))) {
         if(errorMsg.length() > 0)
            errorMsg += "<br>";

         errorMsg += "Email address must contain @ and " +
                     "end in .com or .edu";
         errorDetected = true;
      }
      if(errorDetected) {
         res.getWriter().print(errorMsg);
         nextStop = "/form.jsp";   
      }
      RequestDispatcher rd;
      rd = getServletContext().getRequestDispatcher(nextStop);

      if(nextStop.equals("/form.jsp"))
         rd.include(req, res);
      else
         rd.forward(req, res);
   }
}
