package tags.regions;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;

import beans.regions.Content;
import beans.regions.Region;

public class RegionDefinitionTag extends RegionTag {
   private String scope = null;

   public void setScope(String scope) {
      this.scope = scope;
   }
   public int doStartTag() throws JspException {
      if(region != null && template != null)
         throw new JspException("regions can be created from "  +
                                "a template or another region," +
                                "but not both");
      createRegionFromRegion();

      if(region == null)
         createRegionFromTemplate();

      return EVAL_BODY_INCLUDE;
   }
   public int doEndTag() throws JspException {
      pageContext.setAttribute(id, region, getScope());
      return EVAL_PAGE;
   }
   protected int getScope() {
      int constant = PageContext.PAGE_SCOPE;

      scope = (scope == null) ? "page" : scope;

      if("page".equalsIgnoreCase(scope)) 
         constant = PageContext.PAGE_SCOPE;
      else if("request".equalsIgnoreCase(scope)) 
         constant = PageContext.REQUEST_SCOPE;
      else if("session".equalsIgnoreCase(scope)) 
         constant = PageContext.SESSION_SCOPE;
      else if("application".equalsIgnoreCase(scope)) 
         constant = PageContext.APPLICATION_SCOPE;

      return constant;
   }
   public void release() {
      super.release();
      scope = "page";
   }
}
