import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import beans.LoginDB;
import beans.User;

public class LoginServlet extends HttpServlet {
   private LoginDB loginDB;

   public void init(ServletConfig config) 
                              throws ServletException {
      super.init(config);
      config.getServletContext().setAttribute("loginDB", 
                                         loginDB = new LoginDB());
   }
   public void service(HttpServletRequest req,
                    HttpServletResponse res)
                    throws java.io.IOException, ServletException {
      User user = loginDB.getUser(req.getParameter("userName"),
                                  req.getParameter("password"));

      if(user != null) { // user is in the login database
         req.getSession().setAttribute("user", user);

         getServletContext().getRequestDispatcher(
            res.encodeURL("/welcome.jsp")).forward(req,res);
      }
      else { // user must open a new account or retry login
         getServletContext().getRequestDispatcher(
            res.encodeURL("/loginFailed.jsp")).forward(req,res);
      }
   }
}
