package actions;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import beans.LoginDB;
import beans.User;

public class LoginAction implements Action { 
   public ActionRouter perform(HttpServlet servlet,
                               HttpServletRequest req, 
                               HttpServletResponse res)
                          throws java.io.IOException, 
                               javax.servlet.ServletException {
      LoginDB loginDB = getLoginDB(servlet.getServletContext());
      User user = loginDB.getUser(req.getParameter("userName"),
                                  req.getParameter("password"));

      if(user != null) { // user is in the login database
         req.getSession().setAttribute("user", user);
         return new ActionRouter("welcome-page");
      }
      else { // store userName request parameter in session
         req.getSession().setAttribute("userName",
                          req.getParameter("userName"));
         return new ActionRouter("login-failed-page");
      }
   }
   private LoginDB getLoginDB(ServletContext context) {
      LoginDB loginDB = (LoginDB)context.getAttribute("loginDB");

      if(loginDB == null)
         context.setAttribute("loginDB", loginDB = new LoginDB());

      return loginDB;
   }
}
