package actions;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import actions.Action;
import actions.events.ActionEvent;
import actions.events.ActionListener;
import beans.Token;

public class StateManager implements ActionListener {
   public void beforeAction(ActionEvent event) 
                                       throws ServletException {
      Action action = (Action)event.getSource();
      HttpServletRequest request = event.getRequest();
      HttpSession session = request.getSession();
      String sessionToken = (String)session.getAttribute("token");

      if(action.isSensitive()) {
         String requestToken = (String)
                                request.getParameter("token");
         if(sessionToken == null || requestToken == null ||
                        !sessionToken.equals(requestToken)) {
            throw new ServletException(
                       "Sorry, but this is a sensitive page " +
                       "that can't be resubmitted.");
         }
      }
   }
   public void afterAction(ActionEvent event) 
                                       throws ServletException {
      Action action = (Action)event.getSource();
      HttpServletRequest request = event.getRequest();
      HttpSession session = request.getSession();

      if(action.hasSensitiveForms()) {
         Token token = new Token(request);

         session.setAttribute("token", token.toString());
         request.setAttribute("token", token.toString());
      }
      if(action.isSensitive()) {
         session.removeAttribute("token");
      }
   }
}
