package beans.i18n;

import java.util.*;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;

public class LocaleDetector {
   public Vector detectLocales(HttpServletRequest req,
                               ServletResponse res) {
      Vector locales = getLocalesFromRequest(req);

      if(locales == null) {
         locales = getLocalesByHand(
                               req.getHeader("Accept-Language"));
      }
      return locales;
   }
   private Vector getLocalesFromRequest(HttpServletRequest req) {
      Enumeration locales = null;
      Vector vector = null;

      try {
         locales = req.getLocales();
      }
      catch(Throwable ex) {
         return null;
      }
      if(locales != null) {
         vector = new Vector();

         while(locales.hasMoreElements()) {
            vector.addElement(locales.nextElement());
         }
      }
      return vector;
   }
   private Vector getLocalesByHand(String acceptLanguages) {
      Vector locales = new Vector();
      StringTokenizer tokenizer = 
                      new StringTokenizer(acceptLanguages, ",");

      while(tokenizer.hasMoreTokens()) {
         String tok = tokenizer.nextToken(), language, country;
         int qval = tok.indexOf(';'), dash;

         if(qval >= 0)
            tok = tok.substring(0, qval);   

         dash = tok.indexOf('-');

         if(dash >= 0) {
            language = tok.substring(0, dash);
            country = tok.substring(dash+1);
         }
         else {
            language = tok;
            country = "";
         }
         locales.addElement(new Locale(language, country));
      }
      return locales;
   }
}
