package tags.i18n;

import java.util.Vector;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.tagext.TagSupport;
import beans.i18n.LocaleDetector;

public class DetectLocalesTag extends TagSupport {
   private LocaleDetector detector = new LocaleDetector();
   private boolean force = false;

   public void setForce(String force) {
      this.force = Boolean.valueOf(force).booleanValue();
   }
   public int doStartTag() throws javax.servlet.jsp.JspException {
      HttpSession session = pageContext.getSession();
      Vector locales = (Vector)session.getAttribute("locales"); 

      if(force || locales == null) {
         if(locales != null)
            session.removeAttribute("locales");

         locales = detector.detectLocales(
                     (HttpServletRequest)pageContext.getRequest(),
                     pageContext.getResponse());

         session.setAttribute("locales", locales);
      }
      return SKIP_BODY;
   }
   public void release() {
      force = false;
      detector = null;
   }
}
