import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import beans.LoginDB;
import beans.User;

public class AuthenticateServlet extends HttpServlet {
   private LoginDB loginDB;

   public void init(ServletConfig config) throws ServletException{
      super.init(config);
      loginDB = new LoginDB();
   }
   public void service(HttpServletRequest req,
                         HttpServletResponse res)
                            throws IOException, ServletException {
      HttpSession session = req.getSession();
      String      uname   = req.getParameter("userName");
      String      pwd     = req.getParameter("password");
      User        user    = loginDB.getUser(uname, pwd);
         
      if(user != null) { // authorized
         String protectedPage = (String)session.
                                 getAttribute("protected-page");
         session.removeAttribute("login-page");
         session.removeAttribute("error-page");
         session.removeAttribute("protected-page");
         session.removeAttribute("login-error");

         session.setAttribute("user", user);
         res.sendRedirect(res.encodeURL(protectedPage));
      }
      else { // not authorized
         String loginPage = (String)session.
                            getAttribute("login-page");
         String errorPage = (String)session.
                            getAttribute("error-page");
         String forwardTo = errorPage != null ? errorPage :
                                                loginPage;
         session.setAttribute("login-error",
                  "Username and Password are not valid.");

         getServletContext().getRequestDispatcher(
            res.encodeURL(forwardTo)).forward(req,res);
      }
   }
}
