package tags;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;

public class EnforceLoginTag extends TagSupport {
   private String loginPage, errorPage;

   public void setLoginPage(String loginPage) {
      this.loginPage = loginPage;
   }
   public void setErrorPage(String errorPage) {
      this.errorPage = errorPage;
   }
   public int doEndTag() throws JspException {
      HttpSession session = pageContext.getSession();
      HttpServletRequest req = (HttpServletRequest)pageContext.
                                                 getRequest();
      String protectedPage = req.getRequestURI();

      if(session.getAttribute("user") == null) {
         session.setAttribute("login-page",     loginPage);
         session.setAttribute("error-page",     errorPage);
         session.setAttribute("protected-page", protectedPage);

         try {
            pageContext.forward(loginPage);
            return SKIP_PAGE;
         }
         catch(Exception ex) {
            throw new JspException(ex.getMessage());
         }
      }
      return EVAL_PAGE;
   }
   public void release() {
      loginPage = errorPage = null;
   }
}
